##this function puts together a cluster ensemble function that attempts to 
##cluster together documents that are placed together in a large number of similar 
##clusters.  


cluster_ensemble<- function(cluster.sols, k=10){
	n.docs<- len(cluster.sols[[1]])
	temp.list<- list()
	for(g in 1:len(cluster.sols)){
		temp.sols<- unique(cluster.sols[[g]])
		n.clust<- len(unique(temp.sols))
		temp.mat<- matrix(0, nrow=n.docs, ncol=n.clust)
		for(j in 1:n.clust){
			abc<- which(cluster.sols[[g]]==temp.sols[j])
			temp.mat[abc,j]<- 1
			}
		temp.list[[g]]<- temp.mat
		}
		##now, we concatenate the matrices
		conc.mat<- temp.list[[1]]
		for(g in 2:len(temp.list)){
		conc.mat<- cbind(conc.mat, temp.list[[g]])
		}
		r<- len(cluster.sols)
		S<- (1/r)* conc.mat%*%t(conc.mat)		
		S.prime<- 1- S
		out<- kmeans(S.prime, centers=k)
		return(out$cluster)
		}

