##this implements a fully Bayesian Mixture of Multinomial 
##using a mean-field approximation



galileo2mixmultinomVA<- function(affinity, k = 10, prior.pi= 1, prior.theta = 0.01){
	data<- affinity$data
	data<- as.matrix(data)
	Y<- data
	require(MCMCpack)
	pis<- rgamma(k, shape=1, rate=1/10)

	thetas<- matrix(NA, nrow=ncol(Y), ncol=k)
	
	for(j in 1:ncol(thetas)){
		thetas[,j]<- rgamma(ncol(Y), shape=1, rate=1/10)
		}

	z<- 0
	a<- 0
	taus<- matrix(NA, nrow=nrow(Y), ncol=k)

        alpha<- prior.pi
        lambda <- prior.theta
        
	while(z==0){
	a <- a + 1
	thetas.old<- thetas
	pi.gam<- digamma(pis) - digamma(sum(pis))
	theta.gam<- digamma(thetas) - digamma(apply(thetas, 1, sum))
	y.theta<- Y%*%theta.gam
	y.theta<- y.theta + matrix(pi.gam, nrow=nrow(Y), ncol=k)
	exp.y<- exp(y.theta)
	taus<- exp.y/apply(exp.y, 1, sum)



	pis<- alpha + apply(taus, 2, sum)
	thetas<- lambda + t(Y)%*%taus

	afr<- max(abs(thetas - thetas.old))
	if(afr<1e-4){
		z<- 1}
	}

	clusters<- apply(taus, 1, which.max)
	return(clusters)
	}

